create or replace PROCEDURE PR_EST1 
IS
/******************************************************************************
   Nombre:              PR_EST1
   Propsito:           Modifica el valor de la entrada de la tabla EST1_DESCARGAS. 
                        Esta informacin corresponde al nmero total de descargas 
			realizadas hasta el momento. 
                   
   Parmetros entrada:  sin parmetros            

   Retorna:             'OK' si la ejecucin ha finalizado con xito
                        'ERROR: tipo de error' si ha fracasado
******************************************************************************/
param_entrada VARCHAR2(500);
RSP VARCHAR2 (500);
existe INTEGER;
p_num_descargas NUMBER;
err_msg VARCHAR2 (200);

BEGIN

   param_entrada:='sin parametros';

  -- calculamos el nuevo nmero total de descargas de la plataforma hasta el momento
   SELECT COUNT (*)
   INTO p_num_descargas
   FROM DESCARGA;

  -- calculamos si existe una entrada en la tabla EST1_DESCARGAS
   SELECT COUNT (*)
   INTO existe
   FROM EST1_DESCARGAS;   
  --Si no existe la entrada, la aadimos 
   IF (existe=0) THEN 
     INSERT INTO EST1_DESCARGAS (num_descargas) VALUES (p_num_descargas);     
  --Si existe la actualizamos
   ELSE
     UPDATE EST1_DESCARGAS 
     SET num_descargas=p_num_descargas;
   END IF;  

  -- finaliza con xito
   RSP:='OK';
   PR_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'PR_EST1', param_entrada, 'RSP: '||RSP);

   COMMIT;
EXCEPTION
  -- no finaliza con xito        
   WHEN OTHERS THEN
        err_msg:=SUBSTR (SQLERRM, 1, 200);
        RSP:='ERROR EST1: '||err_msg;
        PR_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'PR_EST1', param_entrada, 'RSP: '||RSP);
        ROLLBACK;
              
END PR_EST1;