SET SERVEROUTPUT ON;
spool pruebas_consultas.log
set echo on

/**************************
     PRUEBAS CONSULTAS        
**************************/ 

/* 
CONSULTA_DESARROLLADORES_PAIS
Dado un país, obtenemos los desarrolladores de dicho país con todos sus datos, 
incluyendo el número de aplicaciones diferentes publicadas
*/
DECLARE
  RSP VARCHAR2(500);
  REFCURSOR SYS_REFCURSOR;
  num_movil NUMBER;
  empresa NUMBER;
  operador VARCHAR2(20);
  correo_electronico VARCHAR2(40);
  pais CHAR(2); 
  num NUMBER;
  identificador VARCHAR2(40);
  ver VARCHAR2(20);
  fecha_subida DATE;
  resolucion_pantalla VARCHAR2(20);
  aplicacion VARCHAR2(40);
  dispositivo NUMBER(15);
  fecha DATE;
  forma_de_pago VARCHAR2(22);
  precio NUMBER;
  usuario NUMBER;
  suma INTEGER;
  anyo NUMBER(4);
BEGIN

  PR_CONS_DESARROLLADORES_PAIS('ES', REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO num_movil,empresa,operador,correo_electronico,pais,num;
    DBMS_OUTPUT.PUT_LINE(to_char(num_movil)||', '||to_char(empresa)||', '||operador||', '||correo_electronico||', '||pais||', '||to_char(num));
  END LOOP;
  CLOSE REFCURSOR;

/* 
CONSULTA_APLICACIONES_ACTIVAS
Obtendremos un listado con todas las aplicaciones activas y sus datos principales, 
ordenadas por el número de descargas que han tenido hasta el momento a nivel mundial
*/

  PR_CONS_APLICACIONES_ACTIVAS(REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO identificador,ver,fecha_subida,resolucion_pantalla,num;
    DBMS_OUTPUT.PUT_LINE(identificador||', '||ver||', '||to_char(fecha_subida)||', '||resolucion_pantalla||', '||to_char(num));
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_DESCARGAS_APLICACION
Dados una aplicación y un año concretos, obtendremos un listado con los países en que 
la aplicación se ha descargado ese año y el número de descargas que ha tenido en cada país
*/

  PR_CONS_DESCARGAS_APLICACION('Aplicacion4', 2012, REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO pais,num;
    DBMS_OUTPUT.PUT_LINE(aplicacion||', '||to_char(anyo)||', '||pais||', '||to_char(num));
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_DESCARGAS_USUARIO
Dado un usuario obtendremos una lista de todas las descargas que ha 
realizado con los datos de cada descarga.
*/

  PR_CONS_DESCARGAS_USUARIO(31415926535, REFCURSOR, RSP);

  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO aplicacion,dispositivo,usuario,pais,fecha,forma_de_pago,precio,operador;
    DBMS_OUTPUT.PUT_LINE(aplicacion||', '||to_char(dispositivo)||', '||to_char(usuario)||', '||pais||', '||to_char(fecha)||', '||forma_de_pago||', '||to_char(precio)||', '||operador);
  END LOOP;
  CLOSE REFCURSOR;


/* 
CONSULTA_USUARIOS_MAX_GASTO
Dado un año concreto, obtendremos el listado de los 20 usuarios que más dinero han gastado 
en descargas, ordenados de mayor a menor gasto
*/

  PR_CONS_USUARIOS_MAX_GASTO(2012, REFCURSOR, RSP);
  
  WHILE REFCURSOR%FOUND
  LOOP
    FETCH REFCURSOR INTO usuario,suma;
    DBMS_OUTPUT.PUT_LINE(anyo||', '||to_char(usuario)||', '||to_char(suma));
  END LOOP;
  CLOSE REFCURSOR;

END;


