SET SERVEROUTPUT ON;
spool pruebas_estadisticas.log
set echo on

/*****************************
     PRUEBAS ESTADISTICAS        
*****************************/ 


DECLARE
   RSP VARCHAR2(200);
   num_desc NUMBER;
   recaud NUMBER;
   anyo NUMBER(4);
   med_desc NUMBER;
   desarroll NUMBER;
   apl VARCHAR2(40);
   pais CHAR(2);
   num_usr NUMBER;
   ingres NUMBER;
   apl_desc NUMBER;
BEGIN
-- R7.1: número total de descargas realizadas hasta el momento. 

SELECT * INTO num_desc FROM EST1_DESCARGAS;
DBMS_OUTPUT.PUT_LINE(to_char(num_desc));

PR_BAJA_DESCARGA('Aplicacion1', 111111111111111, RSP);

SELECT * INTO num_desc FROM EST1_DESCARGAS;
DBMS_OUTPUT.PUT_LINE(to_char(num_desc));


-- R7.2: número total de euros generados en descargas hasta el momento.

SELECT * INTO recaud FROM EST2_RECAUDACION;
DBMS_OUTPUT.PUT_LINE(to_char(recaud));

PR_ALTA_DESCARGA('Aplicacion1', 111111111111111, TO_DATE ('27/10/2011'), 'paypal', 3.5, 'Operador1', RSP);

SELECT * INTO recaud FROM EST2_RECAUDACION;
DBMS_OUTPUT.PUT_LINE(to_char(recaud));


-- R7.3: número medio de aplicaciones descargadas en un año concreto. 

SELECT * INTO anyo, med_desc FROM EST3_MEDIA_DESCARGAS WHERE anyo_est3=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(med_desc));

SELECT * INTO anyo, med_desc FROM EST3_MEDIA_DESCARGAS WHERE anyo_est3=2011;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(med_desc));


-- R7.4: desarrollador con el máximo número de descargas en sus aplicaciones y el número de 
--descargas que ésto representa en un año concreto. 

SELECT * INTO anyo, desarroll, num_desc FROM EST4_DESARROLLADOR_MAX WHERE anyo_est4=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(desarroll)||', '||to_char(num_desc));

SELECT * INTO anyo, desarroll, num_desc FROM EST4_DESARROLLADOR_MAX WHERE anyo_est4=2011;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(desarroll)||', '||to_char(num_desc));


-- R7.5: aplicación que más dinero ha recaudado en descargas en un año determinado y su correspondiente desarrollador. 

SELECT * INTO anyo, apl, desarroll FROM EST5_APLICACION_MAX_REC WHERE anyo_est5=2012;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(apl)||', '||to_char(desarroll));

SELECT * INTO anyo, apl, desarroll FROM EST5_APLICACION_MAX_REC WHERE anyo_est5=2010;
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||to_char(apl)||', '||to_char(desarroll));


-- R7.6: número de usuarios distintos que han hecho al menos una descarga en un país y año determinados. 

SELECT * INTO anyo, pais, num_usr FROM EST6_USUARIOS_DESCARGAS WHERE anyo_est6=2011 AND pais_est6='ES';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(num_usr));

SELECT * INTO anyo, pais, num_usr FROM EST6_USUARIOS_DESCARGAS WHERE anyo_est6=2012 AND pais_est6='FR';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(num_usr));


-- R7.7: ingresos generados por los usuarios en un país y año determinados.

SELECT * INTO anyo, pais, ingres FROM EST7_INGRESOS_PAIS WHERE anyo_est7=2011 AND pais_est7='ES';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(ingres));

SELECT * INTO anyo, pais, ingres FROM EST7_INGRESOS_PAIS WHERE anyo_est7=2012 AND pais_est7='FR';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(ingres));


-- R7.8: número de aplicaciones diferentes descargadas al menos una vez en el país y año indicados.

SELECT * INTO anyo, pais, apl_desc FROM EST8_APLICACIONES_PAIS WHERE anyo_est8=2012 AND pais_est8='ES';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(apl_desc));

SELECT * INTO anyo, pais, apl_desc FROM EST8_APLICACIONES_PAIS WHERE anyo_est8=2012 AND pais_est8='FR';
DBMS_OUTPUT.PUT_LINE(to_char(anyo)||', '||pais||', '||to_char(apl_desc));


END;

